/* 
 * Prolog Sample Code provided by BITWISE MAGAZINE
 * 
 *      http://www.bitwisemag.com
 *
 * This code and information is provided "as is" without warranty of
 * any kind, either expressed or implied, including but not limited
 * to the implied warranties of merchantability and/or fitness for a
 * particular purpose.
 *
 * You may use and modify this code for your personal use only.
 * You may also redistribute this code providing that
 * a) No fee is charged and b) This copyright notice
 * is retained in the source code.
 *
 * You may not use this code for commercial purposes
 * without the express permission of the copyright holder
 *
 * Copyright (c) 2005 Huw Collingbourne 
 *
 */
 
language(delphi).
language(java).
language(smalltalk).
language(lisp).
language(prolog).
language(basic).
language(eiffel).

oop(delphi).
oop(java).
oop(smalltalk).
oop(eiffel).

likes(huw,prolog).
likes(huw,delphi).
likes(dolly,java).
likes(dolly,smalltalk).
likes(dolly,basic).
likes(dolly,prolog).
likes(tammy,java).
likes(tammy,eiffel).
likes(tammy,basic).
likes(dwight,prolog).

likes(reba,Language) :-
	oop(Language),
	not(likes(dolly,Language)).

likes(garth,Language) :-
	likes(reba,Language),
	likes(tammy,Language).


trendylang( L ) :-
	likes(reba,L),
	write(L),write( ' is trendy'),nl.
trendylang( L ) :-
	likes(garth,L),
	write(L),write( ' is trendy'),nl.
trendylang( L ) :-
	write(L),write( ' is not trendy'),nl.


nicelangs :-
	language(L),
	trendylang(L).
